// ***********************************************************
//
// misc.cc
//
// Part of Polyanna, Richard Gault, 2001
//
// Copyright (C) University of Oxford, 2001, 2002
//
// ***********************************************************

#include "misc_headers.h"




// ***********************************************************
// ***                 Non-member functions                ***
// ***********************************************************

int highest_common_factor(int x, int y)
{
  if (x == 0 || y == 0) return 0;

  int larger  = (x>y) ? x : y;
  int smaller = (y>x) ? x : y;
  
  while (smaller != 0)
  {
    larger = larger % smaller;
    int temp = larger;
    larger = smaller;
    smaller = temp;
  }
  return larger;
}




// ***********************************************************




int max(int x, int y)
{
return (x > y) ? x : y;
}



// ***********************************************************



int min(int x, int y)
{
return (x < y) ? x : y;
}



// ***********************************************************




bool is_subset(std::set<int> const &s, std::set<int> const &t)
{
  for (std::set<int>::const_iterator si = s.begin(); si != s.end(); ++si)
  {
    if (t.find(*si) == t.end())
      return false;
  }
  
 return true; 
}




// ***********************************************************




void display_tuple(std::ostream &s, const std::vector<int> &t)
{
  s << "<";
  for (nat i = 0; i < t.size(); ++i)
  {
    if (i != 0)
      s << ",";
    s << t[i];
  }
  s << ">";
}




// ***********************************************************




void display_set(std::ostream& s, const std::set<int> &c)
{
  s << "{";
  for (std::set<int>::const_iterator ci = c.begin(); ci != c.end(); ++ci)
  {
    if (ci != c.begin())
      s << ",";
    s << *ci;
  }
  s << "}";
}


